Attribute VB_Name = "mod_aExcel_International_s4p"
Option Compare Database
Option Explicit
'
'*************** Code Start *****************************************************
' module name: mod_aExcel_International_s4p
'  http://msaccessgurus.com/VBA/Code/aExcel_International.htm
'-------------------------------------------------------------------------------
' Purpose  : read Windows Region International settings using Excel
' Author   : crystal (strive4peace)
' License  : below code
' Code List: www.msaccessgurus.com/code.htm
'-------------------------------------------------------------------------------
'           module level variables
'-------------------------------------------------------------------------------
'dimension Excel Application object
'LATE BINDING
Dim oExcel As Object 'Excel.Application
'EARLY BINDING
'Dim oExcel As Excel.Application
'does Excel need to be Quit?
Dim pBooQuit As Boolean

'-------------------------------------------------------------------------------
'           ExcelOpen
'-------------------------------------------------------------------------------
Private Function ExcelOpen() As Boolean
'180307 strive4peace, 191129
   On Error Resume Next
   ExcelOpen = False
   pBooQuit = False
   Err.Clear
   'use Excel if it is already running
   Set oExcel = GetObject(, "Excel.Application")
   If Err.Number <> 0 Then
      'not running, open Excel
      Set oExcel = CreateObject("Excel.Application")
      'Quit Excel when done
      pBooQuit = True
   End If
   'set return value. True if oExcel is set
   ExcelOpen = Not (oExcel Is Nothing)
End Function

'-------------------------------------------------------------------------------
'           ExcelClose
'-------------------------------------------------------------------------------
Public Sub ExcelClose()
'180307 strive4peace ...191130
   'quit Excel and release oExcel object variable
   On Error Resume Next
   If pBooQuit Then
      If Not oExcel Is Nothing Then
         oExcel.Quit
      End If
      pBooQuit = False
   End If
   Set oExcel = Nothing
   Debug.Print Now() & ", Excel released"
End Sub

'-------------------------------------------------------------------------------
'           Get_Excel_International
'-------------------------------------------------------------------------------
Function Get_Excel_International( _
   piIndex As Integer _
   , Optional pvDefaultValue As Variant _
   ) As Variant
'strive4peace 180309, 180718, 191122
   'RETURN
   ' Windows region setting using Excel
   'PARAMETERS
   '  piIndex = the numeric value of a constant
   'EXAMPLE
   '  sListSeparator = Get_Excel_International(5, ";")
   '  sColumnSeparator = Get_Excel_International(14, ",")
   '
   'set up error handler
   On Error GoTo Proc_Err
   
   Dim vValue As Variant
   
   'initialize return value
   If Not IsNull(pvDefaultValue) Then
      Get_Excel_International = pvDefaultValue
   Else
      Get_Excel_International = Null
   End If
   
   'open Excel if necessary
   If oExcel Is Nothing Then
      'this is kept open so you can get more than one setting
      'without having to initialize Excel again
      If Not ExcelOpen() Then Exit Function
   End If
   'get value for setting
   vValue = oExcel.International(piIndex)
   Get_Excel_International = vValue

Proc_Exit:
   On Error Resume Next
   Exit Function
  
Proc_Err:
   Resume Proc_Exit
End Function

'-------------------------------------------------------------------------------
'           launch
'-------------------------------------------------------------------------------
Sub launch_Get_Excel_International()
'191129 strive4peace
'show various international settings
   'CALLS
   '  Get_Excel_International
   Dim sMsg As String
   
   'get CountryCode using Excel international property
   sMsg = "CountryCode is " & Get_Excel_International(1)
   
   '24HourClock, 33
   sMsg = sMsg & vbCrLf _
      & "Clock is " & _
      IIf(CBool(Get_Excel_International(33)), "24", "12") _
      & "-hour clock"

   'ListSeparator, 5
   sMsg = sMsg & vbCrLf _
      & "ListSeparator is" & Get_Excel_International(5)

   Debug.Print sMsg
   MsgBox sMsg, , "International Settings"

   'close Excel (quit and release)
   Call ExcelClose
      
End Sub

'   You may freely use and share this code
'     provided this license notice and comment lines are not changed;
'     code may be modified provided you clearly note your changes.
'   You may not sell this code alone, or as part of a collection,
'     without my handwritten permission.
'   All ownership rights reserved. Use at your own risk.
'   ~ crystal (strive4peace)  www.msaccessgurus.com
'*************** Code End *******************************************************


